require 'runit/testcase'
require 'runit/cui/testrunner'

require "TestSuiteMethodFactory"

class TestSuiteMethodFactoryTest < RUNIT::TestCase
    def setup()
        @factory1 = TestSuiteMethodFactory.new("ArrayTest")
        @factory2 = TestSuiteMethodFactory.new("Array2Test")
        @factory3 = TestSuiteMethodFactory.new("Array3Test")
    end

    def test_hasSuiteMethod
        assert(!@factory1.hasSuiteMethod?)
        assert(@factory2.hasSuiteMethod?)
        assert(@factory3.hasSuiteMethod?)
    end

    def test_getTestMethods
        assert_equals(["testStack", "testIndex"], @factory1.testMethods)
        assert_equals(["testStack"], @factory2.testMethods)
        assert_equals(["testStack"], @factory3.testMethods)
    end
end

if $0 == __FILE__
  if ARGV.size == 0
    suite = TestSuiteMethodFactoryTest.suite
  else
    suite = RUNIT::TestSuite.new
    ARGV.each do |testmethod|
      suite.add_test(TestSuiteMethodFactoryTest.new(testmethod))
    end
  end
  RUNIT::CUI::TestRunner.run(suite)
end
