
require 'TestSuiteFactory'

def printUsage
	$stderr.puts("usage: ruby makeTestSuite.rb [prefix]")
	$stderr.puts("Try 'ruby makeTestSuite.rb --help' for more information")
end

def printHelp
	$stderr.print <<HELP
usage: ruby makeTestSuite.rb [prefix]
Parse all files which name ends with "Test.h" in the current directory, and list up all methods which matches "void testXXX()".  And makes a TestSuite class files and Tester.cpp.

But if the class has a suite() method, the TestSuite class call the suite() method.

You don't have to define a suite() method by your self.  If you want to define a suite() method, you can do it.

    prefix    prefix of the TestSuite file. The default prefix is "Temp".

(Assumptions)
EThe header file of a class XXX is XXX.h, and the test file is XXXTest.h.
EThe definition of a suite() method is "static Test* suite()" or CPPUNIT_TEST_SUITE.
EAll test methods are public, and start with "void test".
HELP
end

if $0 == __FILE__
	require "getopts"

	unless getopts("", "help")
		$stderr.puts("makeTestSuite.rb: illegal option")
		printUsage
		exit(2)
	end
    
	if $OPT_help
		printHelp
		exit(2)
	end
    
  	prefix = ARGV.shift

    factory = TestSuiteFactory.new(prefix)
    factory.makeTestSuiteFiles

end
